[BACK]Return to fw_install.sh CVS log [TXT][DIR] Up to [local] / openbsd / fw_update

Diff for /openbsd/fw_update/fw_install.sh between version 1.23 and 1.33

version 1.23, 2021/11/11 02:33:32 version 1.33, 2021/11/19 03:13:11
Line 1 
Line 1 
 #!/bin/ksh  #!/bin/ksh
 set -e  set -e
   
 scan_dmesg() {  # Fake up some things from install.sub that we don't need to actually do
         # no bsort for now  
         sed -n "$1" /var/run/dmesg.boot  
 }  
   
 prefetcharea_fs_list() {  prefetcharea_fs_list() {
     echo "/mnt/tmp"          echo "${DESTDIR}/tmp"
 }  }
 reset_watchdog() {  
 }  
   
 # tmpdir, do_as, unpriv, and unpriv2 are from install.sub  # tmpdir, do_as, unpriv, and unpriv2 are from install.sub
   
Line 69 
Line 63 
         do_as _file "$@"          do_as _file "$@"
 }  }
   
 # "fail" needs to be replaced with the "ask_yn" loop like in the installer.  VNAME=${VNAME:-$(sysctl -n kern.osrelease)}
 _issue=  VERSION=${VERSION:"${VNAME%.*}${VNAME#*.}"}
 fail() {  FWDIR=${FWDIR:-$VNAME}
         echo $_issue >&2  MODE=${MODE:-install}
         exit 1  
 }  
   
 VNAME=$(sysctl -n kern.osrelease)  
 VERSION="${VNAME%.*}${VNAME#*.}"  
 FWDIR="$VNAME"  
   
 # TODO: We need the firmware for the system we just installed  # TODO: We need the firmware for the system we just installed
 #       not the one we booted from.  For example:  #       not the one we booted from.  For example:
 #       * booting from a snapshot bsd.rd that thinks it is the 7.0 release  #       * booting from a snapshot bsd.rd that thinks it is the 7.0 release
Line 91 
Line 79 
 #       Otherwise, the fw_update after first boot will fix it up for us.  #       Otherwise, the fw_update after first boot will fix it up for us.
   
 HTTP_FWDIR=$FWDIR  HTTP_FWDIR=$FWDIR
 set -- $(scan_dmesg "/^OpenBSD $VNAME\([^ ]*\).*$/s//\1/p")  set -- sed -n "/^OpenBSD $VNAME\([^ ]*\).*$/s//\1/p" /var/run/dmesg.boot
 [[ $1 == -!(stable) ]] && HTTP_FWDIR=snapshots  [[ $1 == -!(stable) ]] && HTTP_FWDIR=snapshots
   
 FWURL=http://firmware.openbsd.org/firmware/${HTTP_FWDIR}  FWURL=http://firmware.openbsd.org/firmware/${HTTP_FWDIR}
Line 100 
Line 88 
   
 # TODO: support srclocal installation of firmware somehow  # TODO: support srclocal installation of firmware somehow
 fw_update() {  fw_update() {
         local _src=$FWURL _tmpfs_list _tmpfs _tmpsrc          local _src=$1 _tmpfs_list _tmpfs _tmpsrc \
     local _t=Get _cfile="/tmp/SHA256" _srclocal=false                  _t=Get _cfile="/tmp/SHA256" _pkgdir=${DESTDIR}/var/db/pkg \
         local _f _r _remove _i _installed                  _f _r _remove _i _installed
         local _pkgdir=/mnt/var/db/pkg          local _srclocal=false _unpriv=unpriv
   
           echo "Let's $MODE firmware!"
         local _d _drivers=$(          local _d _drivers=$(
                 last=''                  last=''
                 ftp -D "Detecting" -Vmo- $FWPATTERNS |                  $_unpriv ftp -D "Detecting" -Vmo- $FWPATTERNS |
                 while read _d _m; do                  while read _d _m; do
                         grep=grep                          grep=grep
                         [ "$last" = "$_d" ] && continue                          [ "$last" = "$_d" ] && continue
Line 158 
Line 148 
             echo "Cannot fetch SHA256.sig" >&2 && return 1              echo "Cannot fetch SHA256.sig" >&2 && return 1
   
         # Verify signature file with public keys.          # Verify signature file with public keys.
         ! unpriv -f "$_cfile" \          ! $_unpriv -f "$_cfile" \
             signify -Vep $FWPUB_KEY -x "$_cfile.sig" -m "$_cfile" &&              signify -Vep $FWPUB_KEY -x "$_cfile.sig" -m "$_cfile" &&
             echo "Signature check of SHA256.sig failed" >&2 && return 1              echo "Signature check of SHA256.sig failed" >&2 && return 1
   
         for _d in $_drivers; do          for _d in $_drivers; do
                 $UU && reset_watchdog  
                 _f=$( sed -n "s/.*(\($_d-firmware-.*\.tgz\)).*/\1/p" "$_cfile" )                  _f=$( sed -n "s/.*(\($_d-firmware-.*\.tgz\)).*/\1/p" "$_cfile" )
                 _installed=$(                  _installed=$(
                 for fw in "${_pkgdir}/$_d-firmware"*; do                  for fw in "${_pkgdir}/$_d-firmware"*; do
Line 174 
Line 163 
   
                 for _i in $_installed; do                  for _i in $_installed; do
                         if [ "$_f" = "$_i.tgz" ]; then                          if [ "$_f" = "$_i.tgz" ]; then
                                 echo "Firmware for $_d already installed ($_installed)"                                  echo "$_i already installed"
                                 continue 2                                  continue 2
                         fi                          fi
                 done                  done
Line 211 
Line 200 
   
                         while read c g; do                          while read c g; do
                                 case $c in                                  case $c in
                                 @cwd) cwd="/mnt/$g"                                  @cwd) cwd="${DESTDIR}/$g"
                                   ;;                                    ;;
                                 @*) continue                                  @*) continue
                                   ;;                                    ;;
Line 234 
Line 223 
                 fi                  fi
   
                 # TODO: Should we mark these so real fw_update can -Drepair?                  # TODO: Should we mark these so real fw_update can -Drepair?
                 $_unpriv ftp -D "Install" -Vmo- "file:$_tmpsrc/$_f" |                  ftp -D "Install" -Vmo- "file:$_tmpsrc/$_f" |
             tar -s ",^\+,${_pkgdir}/${_f%.tgz}/+," \                          tar -s ",^\+,${_pkgdir}/${_f%.tgz}/+," \
                 -s ",^firmware,mnt/etc/firmware," \                          -s ",^firmware,${DESTDIR}/etc/firmware," \
                 -C / -zxphf - \                          -C / -zxphf - "+*" "firmware/*"
                 "+*" "firmware/*"  
   
                 ed -s "${_pkgdir}/${_f%.tgz}/+CONTENTS" <<EOL                  ed -s "${_pkgdir}/${_f%.tgz}/+CONTENTS" <<EOL
 /^@comment pkgpath/ -1a  /^@comment pkgpath/ -1a
Line 251 
Line 239 
         done          done
 }  }
   
 fw_update  fw_update "$FWURL"

Legend:
Removed from v.1.23  
changed lines
  Added in v.1.33

FreeBSD-CVSweb <freebsd-cvsweb@FreeBSD.org>